close all;
clear all;

FontSize=16;
FontName='Times New Roman';

%% Tester begge filterne for  se hvordan de pvirker SNR

%Laster inn signal fra signalgenerator fr og etter BP-filter for begge
%filterne, og fjerner DC med  trekke fra middelverdien
x_utenL6204=textread('test_av_BPL6204_utenBP_2us_2.5GS_1.2pkpk.dat')';
x_utenL6204=x_utenL6204-mean(x_utenL6204);
x_medL6204=textread('test_av_BPL6204_medBP_2us_2.5GS_0.7pkpk.dat')';
x_medL6204=x_medL6204-mean(x_medL6204);

x_utenL6205=textread('test_av_BPL6205_utenBP_2us_2.5GS_1.2pkpk.dat')';
x_utenL6205=x_utenL6205-mean(x_utenL6205);
x_medL6205=textread('test_av_BPL6205_medBP_2us_2.5GS_0.7pkpk.dat')';
x_medL6205=x_medL6205-mean(x_medL6205);

%Plotter frekvensresponsen til inngangen med og uten BP filter L6204

%punktprvingsfrekvens
fs=2.5e9;

%Antall punkter til FFT-algoritmen
NFFT=2^(nextpow2(length(x_utenL6204)));

%Beregner frekvensresponsen med Hanning-vindu
X_utenL6204=fft(x_utenL6204.*window(@hann,length(x_utenL6204))',NFFT);
X_medL6204=fft(x_medL6204.*window(@hann,length(x_medL6204))',NFFT);

%Frekvensvektor til frekvensresponsen
f=linspace(-0.5*fs,0.5*fs,NFFT);

%Plotter frekvensresponsen til punkt 2
figure();
plot(f./1e6,20*log10(fftshift(X_utenL6204./max(X_utenL6204))));
title('Frekvensspekter uten L6204, fs=2.5GHz, NFFT=8192', 'FontSize', FontSize,'FontName',FontName);
xlabel('f [MHz]','FontSize', FontSize,'FontName',FontName);
ylabel('|X(f)| [dB]','FontSize', FontSize,'FontName',FontName);
axis([0 500 -80 3]);
set(gca, 'FontSize', FontSize,'FontName',FontName);

figure();
plot(f./1e6,20*log10(fftshift(X_medL6204./max(X_utenL6204))));
title('Frekvensspekter med L6204, fs=2.5GHz, NFFT=8192', 'FontSize', FontSize,'FontName',FontName);
xlabel('f [MHz]','FontSize', FontSize,'FontName',FontName);
ylabel('|X(f)| [dB]','FontSize', FontSize,'FontName',FontName);
axis([0 500 -80 3]);
set(gca, 'FontSize', FontSize,'FontName',FontName);


%Beregner frekvensresponsen med Blackman-Harris vindu
X_utenL6204=fft(x_utenL6204.*window(@blackmanharris,length(x_utenL6204))');
X_medL6204=fft(x_medL6204.*window(@blackmanharris,length(x_medL6204))');
X_utenL6205=fft(x_utenL6205.*window(@blackmanharris,length(x_utenL6205))');
X_medL6205=fft(x_medL6205.*window(@blackmanharris,length(x_medL6205))');

%Plotter frekvensresponsen for  finne signal- og stykomponenter
% figure();
% stem(abs(X_utenL6204));

%Definerer sty- og signaleffekter
s_utenL6204=0;n_utenL6204=0;
s_medL6204=0;n_medL6204=0;
s_utenL6205=0;n_utenL6205=0;
s_medL6205=0;n_medL6205=0;

%Gr igjennom frekvensresponsen og summerer signal- og stykomponenter
for i=1:length(X_utenL6204)
    if i>=253 && i<=261 || i>=4741 && i<=4749  
        s_utenL6204=s_utenL6204+(abs(X_utenL6204(i))^2);
        s_medL6204=s_medL6204+(abs(X_medL6204(i))^2);
        s_utenL6205=s_utenL6205+(abs(X_utenL6205(i))^2);
        s_medL6205=s_medL6205+(abs(X_medL6205(i))^2);
    else
        n_utenL6204=n_utenL6204+(abs(X_utenL6204(i))^2);
        n_medL6204=n_medL6204+(abs(X_medL6204(i))^2);
        n_utenL6205=n_utenL6205+abs(X_utenL6205(i))^2;
        n_medL6205=n_medL6205+abs(X_medL6205(i))^2;
   end
end

%Beregner SNR for alle de 4 tilfellene
SNR_utenL6204=10*log10(s_utenL6204/n_utenL6204);
SNR_medL6204=10*log10(s_medL6204/n_medL6204);
SNR_utenL6205=10*log10(s_utenL6205/n_utenL6205);
SNR_medL6205=10*log10(s_medL6205/n_medL6205);

%% Plotter og analyserer utgangen til ZOH- og RTZ-kretsen

%Punkt 2: Etter FPGA-krets
x_pk2=textread('pk2_10us_2.5GS_1.6pkpk.dat')';
x_pk2=x_pk2-mean(x_pk2);

%Punkt 3: Etter RTZ-krets
x_pk3=textread('pk3_10us_2.5GS_480pkpk.dat')';
x_pk3=x_pk3-mean(x_pk3);

%punktprvingsfrekvens
fs=2.5e9;

%Antall punkter til FFT-algoritmen
NFFT=2^(nextpow2(length(x_pk2)));

%Frekvensvektor til frekvensresponsen
f=linspace(-0.5*fs,0.5*fs,NFFT);

%Definerer dempningen til blgeformen
%RTZ-DAC med T=3.68ns
b1=ones(1,round((1/(40e6))*fs));
%RTZ-DAC med T=5.6ns
b2=zeros(1,round((1/(40e6))*fs));
b2(1:round(4e-9*fs))=1;

%Beregner frekvensresponsen til blgeformene
B1=fft(b1,NFFT)/length(b1);
B2=fft(b2,NFFT)/length(b2);

%Beregner frekvensresponsen
X_pk2=fft(x_pk2.*window(@hann,length(x_pk2))',NFFT);
X_pk3=fft(x_pk3.*window(@hann,length(x_pk3))',NFFT);

%Plotter frekvensresponsen til punkt 2
figure();
plot(f./1e6,20*log10(fftshift(abs(X_pk2)./max(abs(X_pk2))))+20*log10(sinc(600e6*(1/fs))));
title('Frekvensspekter etter FPGA-krets, fs=2.5GHz, NFFT=32768', 'FontSize', FontSize,'FontName',FontName);
xlabel('f [MHz]','FontSize', FontSize,'FontName',FontName);
ylabel('|X(f)| [dB]','FontSize', FontSize,'FontName',FontName);
axis([0 140 -80 3]);
set(gca, 'FontSize', FontSize,'FontName',FontName);
hold on;
plot(f./1e6,20*log10(fftshift(abs(B1)./max(abs(B1)))),'m:');
hleg=legend('ZOH-DAC','Dempning ideell ZOH-DAC',2);
set(hleg,'FontSize', 12,'FontName','Times New Roman');
hold off;

%Plotter frekvensresponsen til punkt 3
figure();
plot(f./1e6,20*log10(fftshift(abs(X_pk3)./max(abs(X_pk3)))));
title('Frekvensspekter etter RTZ-krets, fs=2.5GHz, NFFT=32768', 'FontSize', FontSize,'FontName',FontName);
xlabel('f [MHz]','FontSize', FontSize,'FontName',FontName);
ylabel('|X(f)| [dB]','FontSize', FontSize,'FontName',FontName);
axis([0 140 -70 3]);
set(gca, 'FontSize', FontSize,'FontName',FontName);
hold on;
plot(f./1e6,20*log10(fftshift(abs(B2)./max(abs(B2)))),'m--');
hleg=legend('RTZ-krets','Dempning ideell RTZ-DAC',2);
set(hleg,'FontSize', 12,'FontName','Times New Roman');
hold off;

%%
%Innsignal
x_inn=textread('test_av_BPL6204_medBP_2us_2.5GS_0.7pkpk.dat')';
x_inn=x_inn-mean(x_inn);

%Utsignal
x_ut=textread('utsignal_2us_2.5GS_20mVpkpk.dat')';
x_ut=x_ut-mean(x_ut);

%Terminert scoop
x_term=textread('terminering_scoop.dat')';
x_term=x_term-mean(x_term);

%Beregner frekvensresponsen
X_inn=fft(x_inn.*window(@blackmanharris,length(x_inn))');
X_ut=fft(x_ut.*window(@blackmanharris,length(x_ut))');


% figure();
% stem(abs(X_ut));

%Beregner sty og signaleffekter
s_inn=0;n_inn=0;
s_ut=0;n_ut=0;
for i=1:length(X_inn)
    if i>=253 && i<=261 || i>=4741 && i<=4749  
        s_inn=s_inn+(abs(X_inn(i))^2);
        s_ut=s_ut+(abs(X_ut(i))^2);
    else
        n_inn=n_inn+abs(X_inn(i))^2;
        n_ut=n_ut+(abs(X_ut(i))^2);
   end
end

SNR_inn=10*log10(s_inn/n_inn);
SNR_ut=10*log10(s_ut/n_ut);

%Antall punkter til FFT-algoritmen
NFFT=2^(nextpow2(length(x_inn)));

%Beregner frekvensresponsen
X_inn=fft(x_inn.*window(@hann,length(x_inn))',NFFT);
X_ut=fft(x_ut.*window(@hann,length(x_ut))',NFFT);
X_term=fft(x_term.*window(@hann,length(x_term))',NFFT);

%Frekvensvektor
f=linspace(-0.5*fs,0.5*fs,NFFT);

%Plotter frekvensresponsen
%Innsignal
figure();
plot(f./1e6,20*log10(fftshift(abs(X_inn)./max(abs(X_inn)))));
title('Frekvensspekter inngangssignal, fs=2.5GHz, NFFT=8192', 'FontSize', FontSize,'FontName',FontName);
xlabel('f [MHz]','FontSize', FontSize,'FontName',FontName);
ylabel('|X(f)| [dB]','FontSize', FontSize,'FontName',FontName);
axis([0 250 -80 3]);
set(gca, 'FontSize', FontSize,'FontName',FontName);
%Utsignal
figure();
plot(f./1e6,20*log10(fftshift(abs(X_ut)./max(abs(X_ut)))));
title('Frekvensspekter inngangssignal, fs=2.5GHz, NFFT=8192', 'FontSize', FontSize,'FontName',FontName);
xlabel('f [MHz]','FontSize', FontSize,'FontName',FontName);
ylabel('|X(f)| [dB]','FontSize', FontSize,'FontName',FontName);
axis([0 250 -80 3]);
set(gca, 'FontSize', FontSize,'FontName',FontName);
%Utsignal sammen med terminert stygulv fra oscilloskop
figure();
plot(f./1e6,20*log10(fftshift(abs(X_ut)./max(abs(X_ut)))));
hold on;
plot(f./1e6,20*log10(fftshift(abs(X_term)./max(abs(X_ut)))),'m');
title('Frekvensspekter inngangssignal, fs=2.5GHz, NFFT=8192', 'FontSize', FontSize,'FontName',FontName);
xlabel('f [MHz]','FontSize', FontSize,'FontName',FontName);
ylabel('|X(f)| [dB]','FontSize', FontSize,'FontName',FontName);
axis([0 250 -80 3]);
set(gca, 'FontSize', FontSize,'FontName',FontName);
hleg=legend('Utgang totalsystem','Stygulv fra oscilloskop',2);
set(hleg,'FontSize', 12,'FontName','Times New Roman');