close all;
clear all;

FontSize=16;
FontName='Times New Roman';

%%
%Innsignal
x_inn=textread('innsignal_10us_5Gs_580pkpk.dat')';
x_inn=x_inn-mean(x_inn);

%Punkt 2: Etter FPGA-krets
x_pk2=textread('ZOH_10us_5GS_450pkpk.dat')';
x_pk2=x_pk2-mean(x_pk2);

%Punkt 3: Etter RTZ-krets
x_pk3=textread('RTZ_10us_5GS_450pkpk.dat')';
x_pk3=x_pk3-mean(x_pk3);

%Utsignal
x_ut=textread('utsignal_10us_5Gs_16pkpk.dat')';
x_ut=x_ut-mean(x_ut);

%Utsignal senario 1
x_ut1=textread('Senario1_utgang_10us_5GS_13pkpk.dat')';
x_ut1=x_ut1-mean(x_ut1);

%Utsignal senario 2
x_ut2=textread('Senario2_utgang_10us_5GS_11pkpk.dat')';
x_ut2=x_ut2-mean(x_ut2);

%Utsignal senario 3
x_ut3=textread('Senario3_utgang_10us_5GS_11pkpk.dat')';
x_ut3=x_ut3-mean(x_ut3);

%Antall punkter til fft-algortimen
NFFT=2^(nextpow2(length(x_inn)));

%Beregner frekvensresponsen
X_inn=fft(x_inn.*window(@hann,length(x_inn))',NFFT);
X_pk2=fft(x_pk2.*window(@hann,length(x_pk2))',NFFT);
X_pk3=fft(x_pk3.*window(@hann,length(x_pk3))',NFFT);
X_ut=fft(x_ut.*window(@hann,length(x_ut))',NFFT);
X_ut1=fft(x_ut1.*window(@hann,length(x_ut1))',NFFT);
X_ut2=fft(x_ut2.*window(@hann,length(x_ut2))',NFFT);
X_ut3=fft(x_ut3.*window(@hann,length(x_ut3))',NFFT);

%Punktprvingsfrekvens
fs=5e9;

%Frekvensvektor
f=linspace(-0.5*fs,0.5*fs,NFFT);

%Definerer dempningen til blgeformen
%RTZ-DAC med T=3.68ns
b1=ones(1,round((1/(40e6))*fs));
%RTZ-DAC med T=5.6ns
b2=zeros(1,round((1/(40e6))*fs));
b2(1:round(4e-9*fs))=1;

%Beregner frekvensresponsen til blgeformene
B1=fft(b1,NFFT)/length(b1);
B2=fft(b2,NFFT)/length(b2);

%Plotter frekvensresponsen
%Innsignal
figure();
plot(f./1e6,20*log10(fftshift(abs(X_inn)./max(abs(X_inn)))));
title('Frekvensspekter inngangssignal, fs=5GHz, NFFT=65536', 'FontSize', FontSize,'FontName',FontName);
xlabel('f [MHz]','FontSize', FontSize,'FontName',FontName);
ylabel('|X(f)| [dB]','FontSize', FontSize,'FontName',FontName);
axis([0 300 -80 3]);
set(gca, 'FontSize', FontSize,'FontName',FontName);

%Plotter frekvensresponsen til punkt 2
figure();
plot(f./1e6,20*log10(fftshift(abs(X_pk2)./max(abs(X_pk2))))+20*log10(sinc(600e6*(1/fs))));
title('Frekvensspekter etter FPGA-krets, fs=5GHz, NFFT=65536', 'FontSize', FontSize,'FontName',FontName);
xlabel('f [MHz]','FontSize', FontSize,'FontName',FontName);
ylabel('|X(f)| [dB]','FontSize', FontSize,'FontName',FontName);
axis([0 140 -80 3]);
set(gca, 'FontSize', FontSize,'FontName',FontName);
hold on;
plot(f./1e6,20*log10(fftshift(abs(B1)./max(abs(B1)))),'m:');
hleg=legend('ZOH-DAC','Dempning ideell ZOH-DAC',2);
set(hleg,'FontSize', 12,'FontName','Times New Roman');
hold off;

%Plotter frekvensresponsen til punkt 3
figure();
plot(f./1e6,20*log10(fftshift(abs(X_pk3)./max(abs(X_pk3)))));
title('Frekvensspekter etter RTZ-krets, fs=5GHz, NFFT=65536', 'FontSize', FontSize,'FontName',FontName);
xlabel('f [MHz]','FontSize', FontSize,'FontName',FontName);
ylabel('|X(f)| [dB]','FontSize', FontSize,'FontName',FontName);
axis([0 140 -80 3]);
set(gca, 'FontSize', FontSize,'FontName',FontName);
hold on;
plot(f./1e6,20*log10(fftshift(abs(B2)./max(abs(B2)))),'m--');
hleg=legend('RTZ-krets','Dempning ideell RTZ-DAC',2);
set(hleg,'FontSize', 12,'FontName','Times New Roman');
hold off;

%Utsignal
figure();
plot(f./1e6,20*log10(fftshift(abs(X_ut)./max(abs(X_ut)))));
title('Frekvensspekter utsignal, fs=5GHz, NFFT=65536', 'FontSize', FontSize,'FontName',FontName);
xlabel('f [MHz]','FontSize', FontSize,'FontName',FontName);
ylabel('|X(f)| [dB]','FontSize', FontSize,'FontName',FontName);
axis([0 300 -80 3]);
set(gca, 'FontSize', FontSize,'FontName',FontName);

%Utsignal senario 1
figure();
plot(f./1e6,20*log10(fftshift(abs(X_ut1)./max(abs(X_ut1)))));
title('Frekvensspekter utsignal senario 1, fs=5GHz, NFFT=65536', 'FontSize', FontSize,'FontName',FontName);
xlabel('f [MHz]','FontSize', FontSize,'FontName',FontName);
ylabel('|X(f)| [dB]','FontSize', FontSize,'FontName',FontName);
axis([120 140 -70 3]);
set(gca, 'FontSize', FontSize,'FontName',FontName);
%Utsignal senario 2
figure();
plot(f./1e6,20*log10(fftshift(abs(X_ut2)./max(abs(X_ut2)))));
title('Frekvensspekter utsignal senario 2, fs=5GHz, NFFT=65536', 'FontSize', FontSize,'FontName',FontName);
xlabel('f [MHz]','FontSize', FontSize,'FontName',FontName);
ylabel('|X(f)| [dB]','FontSize', FontSize,'FontName',FontName);
axis([120 140 -70 3]);
set(gca, 'FontSize', FontSize,'FontName',FontName);
%Utsignal senario 3
figure();
plot(f./1e6,20*log10(fftshift(abs(X_ut3)./max(abs(X_ut3)))));
title('Frekvensspekter utsignal senario 3, fs=5GHz, NFFT=65536', 'FontSize', FontSize,'FontName',FontName);
xlabel('f [MHz]','FontSize', FontSize,'FontName',FontName);
ylabel('|X(f)| [dB]','FontSize', FontSize,'FontName',FontName);
axis([120 140 -70 3]);
set(gca, 'FontSize', FontSize,'FontName',FontName);
