function [X f] = plotSpektrum(x, Fsa, xmin, xmax, ymin, ymax, tittel, 
                              xakse, yakse, farge, normaliseringsverdi)
    %function [X f] = plotSpektrum(x, Fsa, xmin, xmax, ymin, ymax, tittel, 
    %                         xakse, yakse, farge, normaliseringsverdi)
    %
    %Funksjon som genererer frekvensspektrum og frekvensvektorer av
    %inngangsvektoren x, som er samplet med Fsa. xmin, xmax, ymin, ymax,
    %setter grensene p aksene.  tittel definerer tittelen. xakse beskriver
    %navnet p xaksen. yakse beskriver navnet p yaksen. farge beskriver
    %hvilken farge plottet skal f(se help plot for beskrivelse).
    %normaliseringsverdi normaliserer plottet med denne verdien.



    NFFT=2^(nextpow2(length(x))+4);
    X=fft(x.*window(@hann,length(x))',NFFT);
    figure();
    f=[-NFFT/2:NFFT/2-1]/NFFT;
    %Sjekker om plottet skal normaliseres med men maksverdien til X eller
    %ikke.
    if normaliseringsverdi == 0    
        normaliseringsverdi=max(abs(X));    
    end
    plot(f.*Fsa/1e+9,20*log10(fftshift(abs(X))./normaliseringsverdi),farge);
    
    %Setter riktig font og strrelse
    FontSize=16;
    FontName='Times New Roman';
    
    title(tittel, 'FontSize', FontSize,'FontName',FontName);
    xlabel(xakse,'FontSize', FontSize,'FontName',FontName);
    ylabel(yakse,'FontSize', FontSize,'FontName',FontName);
    
    axis([xmin xmax ymin ymax]);
    set(gca, 'FontSize', FontSize,'FontName',FontName);
end