function sample = sample(x,AT,fc)
    %function sample = sample(x,AT,fc)
    %
    %funksjon som tar inn en vektor x, en acquisition time AT og en 
    %cut-off frekvens fc. fc bestemmer 3-dB bndbredden til 
    %RC-filteret, som fungerer som en ikke-ideell sampler. AT 
    %beskriver tiden sampleren bruker p  oppn samplet. utgangen, 
    %sample, er utgangen av filteret etter tidenAT. 
    
    % 1. ordens RC filter
    wc=2*pi*fc;%regner ut vinkelfrekvensen
    tau = 1/wc;% = RC (identitet hentet fra nilsson s 662)
    
    %m lage ny tidsvektor sa. h defineres fra 0 til acquistion tiden.
    t=0:AT/length(x):AT;                   
    %definerer sample-filteret
    h=(1/tau)*exp(-t./tau);
    %m gange med tiden det skal "integreres" over og dele p antall
    %punkter for  f riktig skalering.
    y=conv(x,h)*AT/length(t);               
    %henter ut riktig sampleverdi
    sample=y(length(t));                         
end