%% 2-TONE TESTBENK FOR ET TOTALSYSTEM 

% DETTE MATLAB SCRIPTET SIMULERER ET TOTALSYSTEM. ALLER FRST
% BLIR INNGANGSPARAMETERNE SATT. DERETTER BLIR RIKTIG 
% SAMPLINGSFREKVENS SATT UTIFRA INNGANGPARAMETERNE. PARAMETERE 
% FOR REELL SAMPLER OG RTZ-DAC BLIR SATT. DERETTER BLIR DET 
% UTFRT IDEELL UNDERSAMPLING, UNDERSAMPLING MED "REELL" SAMPLER 
% OG UNDERSAMPLING MED REELL SAMPELR OG JITTER. SUC FRER 
% SIGNALET OPP TIL NSKET PASSBND IGJEN VHA. EN RTZ-DAC. 
% TILSLUTT BLIR DET SIMULERT OPPKONVERTERING MED JITTER P DACEN.

clear all;
close all;

% INNGANGSPARAMETERE
F1=0.7e+9;          %Testsignalfrekvenser
F2=0.6e+9;          %Testsignalfrekvenser
Fc=9e+9;            %Breblgefrekvens
B=1e9;              %Omhylningsbndbredde bndbredde
FL=Fc;              %Laveste frekvens i omhylningen
FH=FL+B;            %Hyeste frekvens i omhylningen
tidsluke=1e-6;      %Varighet p testssignalet


% VALG AV SAMPLINGSFREKVENS 
%Finner hyeste NQ-bnd k, og evt. korrigerer til oddetall
k=floor(FH/B);
if mod(k,2)
    k=k;
else
    k=k-1;
end
fs=2*FL/(k-1);          %Reell samplingsfrekvens for undersampling
fsa=400*fs;             %Fiktiv "analog" samplingsfrekvens


% PARAMETERE TIL REELL SAMPLER
fco=20e+9;              %cut-off frekvens for RC-filter-sampleren.
tau=1/(2*pi*fco);       %tidskonstant
AT=4*tau;               %Acquisition time

%nsket opplsning i sampleren
n_ps=10;                %#punktprver/ps
n_s=n_ps*1e+12;         %#punktprver/s

% JITTER
jitterRMS=1e-12;      %RMS verdien av jitter
jitter=(jitterRMS).*randn(1,length((1/fs):1/fs:tidsluke-(1/fs)));

% PARAMETERE FOR RTZ-DAC
T=50e-12;              %(NB! T<=Ts=1/fs)

%Font til plott
FontSize=16;
FontName='Times New Roman';
%% UNDERSAMPLER

% PUNKTPRVINGSVEKTORER
t=zeros(1,round(n_s*AT));      %for utsnitt av passbndsignal
tj=zeros(1,round(n_s*AT));     %for utsnitt av passbndsignal med jitter

%henter kun ut nskede verdiene rundt fs, men 1. sample = 0.
teller=1;
for i=(1/fs):1/fs:tidsluke-(1/fs)
    t=[t (i-(round(n_s*AT)-1)/n_s):1/n_s:i];
    tj=[tj (i-(round(n_s*AT)-1)/n_s)+jitter(teller):1/n_s:i+jitter(teller)];
    teller=teller+1;
end

% UTSNITT AV PASSBNDSIGNALENE
xrf=sin((2*pi)*(F1+Fc).*t)+sin((2*pi)*(F2+Fc).*t);      
xrfj=sin((2*pi)*(F1+Fc).*tj)+sin((2*pi)*(F2+Fc).*tj);   %med jitter

% UNDERSAMPLING
x=zeros(1,tidsluke/(1/fs));            
xj=zeros(1,tidsluke/(1/fs));    %med jitter

%undersampler ved  sende et gitt antall "analoge" punktprver til
%sampleren
teller=0;
for i=1:length(t)/(tidsluke/(1/fs)):length(t)
    teller=teller+1;
    x(teller)=sample(xrf(i:i+round(n_s*AT)-1),AT,fco);              
    xj(teller)=sample(xrfj(i:i+round(n_s*AT)-1),AT,fco);
end

%% FLYTTER SIGNALET OPP I FREKVENS VHA. SUC

%Blgeform
rtz_50=zeros(1,round((1/fs)*fsa));
rtz_50(1:round(T*fsa))=1;

%Legger til jitter i DACen
t=0:(1/fs):(tidsluke)-(1/fs);
tj=t+jitterRMS*randn(1,length(t)); 
xb=sin((2*pi)*F1.*t)+sin((2*pi)*F2.*t);
xbj=sin((2*pi)*F1.*tj)+sin((2*pi)*F2.*tj);
e=xb-xbj;
xjj=xj+e;

%Utganger
xrtz=DAComformer(x,rtz_50);
xrtzj=DAComformer(xj,rtz_50);
xrtzjj=DAComformer(xjj,rtz_50);

%Fouriertransformerer utgangene
Xrtz=fft(xrtz.*window(@hann,length(xrtz))',2^(nextpow2(length(xrtz))+2));
Xrtzj=fft(xrtzj.*window(@hann,length(xrtzj))',2^(nextpow2(length(xrtzj))+2));
Xrtzjj=fft(xrtzjj.*window(@hann,length(xrtzjj))',2^(nextpow2(length(xrtzjj))+2));

%FINNER FREKVENSRESPONSEN TIL PASSBNDSIGNALET FOR  F RIKTIG
%NORMALISERINGSVERDI FRA INNGANGSIGNALET
t=0:(1/fsa):(tidsluke)-(1/fsa);
xrf=sin((2*pi)*(F1+Fc).*t)+sin((2*pi)*(F2+Fc).*t);
Xrf=fft(xrf.*window(@hann,length(xrf))',2^(nextpow2(length(xrf))+2));

%PLOTTER FOURIERTRANSDORMEN TIL UTGANGEN FOR RTZ-DACEN
figure();
plot(linspace(-0.5*fsa/1e9,0.5*fsa/1e9,length(Xrtz)),20*log10(fftshift(abs(Xrtz))/max(abs(Xrtz))));
set(gca, 'FontSize', FontSize,'FontName',FontName);
xlabel('Frekvens [GHz]','FontSize', FontSize,'FontName',FontName);
ylabel('|X_{rtz}|','FontSize', FontSize,'FontName',FontName);
title('Frekvensspekter |X_{rtz}|', 'FontSize', FontSize,'FontName',FontName);
axis([0 25 -70 2]);

figure();
plot(linspace(-0.5*fsa/1e9,0.5*fsa/1e9,length(Xrtzj)),20*log10(fftshift(abs(Xrtzj))/max(abs(Xrtzj))));
set(gca, 'FontSize', FontSize,'FontName',FontName);
xlabel('Frekvens [GHz]','FontSize', FontSize,'FontName',FontName);
ylabel('|X_{rtzj}|','FontSize', FontSize,'FontName',FontName);
title('Frekvensspekter |X_{rtzj}|', 'FontSize', FontSize,'FontName',FontName);
axis([0 25 -70 2]);

figure();
plot(linspace(-0.5*fsa/1e9,0.5*fsa/1e9,length(Xrtzjj)),20*log10(fftshift(abs(Xrtzjj))/max(abs(Xrtzjj))));
set(gca, 'FontSize', FontSize,'FontName',FontName);
xlabel('Frekvens [GHz]','FontSize', FontSize,'FontName',FontName);
ylabel('|X_{rtzjj}|','FontSize', FontSize,'FontName',FontName);
title('Frekvensspekter |X_{rtzjj}|', 'FontSize', FontSize,'FontName',FontName);
axis([0 25 -70 2]);

figure();
plot(linspace(-0.5*fsa/1e9,0.5*fsa/1e9,length(Xrtzjj)),20*log10(fftshift(abs(Xrtzjj))/max(abs(Xrf))));
set(gca, 'FontSize', FontSize,'FontName',FontName);
xlabel('Frekvens [GHz]','FontSize', FontSize,'FontName',FontName);
ylabel('|X_{rtzjj}|','FontSize', FontSize,'FontName',FontName);
title('Frekvensspekter |X_{rtzjj}|', 'FontSize', FontSize,'FontName',FontName);
axis([8*fs/2e9 9*fs/2e9 -80 2]);


